from py.test import raises
from os.path import join
import autopath
from creole.lint import creolelint
from creole.lint.test.data.creolevars import creolevars, tmplvars

data = join(autopath.here, 'data')

def test_launch():
    linter = creolelint.CreoleLinter()
    assert linter.__class__ == creolelint.CreoleLinter

def test_singleton():

    linter = creolelint.CreoleLinter()
    linter2 = creolelint.CreoleLinter()

    assert linter == linter2

def test_load_eoledict():
    linter = creolelint.CreoleLinter()
    raises(Exception, linter.load_dics)
    raises(TypeError, linter.set_config, eoledirs=join(data, 'dicos'))
    linter.set_config (eoledirs=[join(data, 'dicos')])
    linter.load_dics()
    creolevars.sort()
    assert linter.get_vars_name() == creolevars

def test_load_tmplvars():
    linter = creolelint.CreoleLinter()
    raises(Exception, linter.load_tmpls)
    raises(TypeError, linter.set_config, distrib_dir=[join(data, 'distrib')])
    linter.set_config(distrib_dir=join(data, 'distrib'))
    linter.load_tmpls()
    tmplvars.sort()
    assert linter.get_tmplvars_name() == tmplvars
